package com.nisum.Clients;

import com.nisum.HateoasApplication;
import com.nisum.constants.Constants;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;
import org.springframework.beans.factory.annotation.Autowired;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;

public class HttpClient {

    @Autowired
    HateoasApplication hateoasApplication;



    //Using HTTP (Method 2)
    public void getUsingHttpClient() throws IOException, ParseException {

        try {
            DefaultHttpClient httpClient = new DefaultHttpClient();
            HttpGet getRequest = new HttpGet(Constants.URL_EMPLOYEES);
            getRequest.addHeader("accept", "application/json");
            HttpResponse response = httpClient.execute(getRequest);

            if (response.getStatusLine().getStatusCode() != 200) {
                throw new RuntimeException("Failed : HTTP error code : "
                        + response.getStatusLine().getStatusCode());
            } else {

                int i = 0;
                JSONObject obj = null;
                do {
                    if (i == 0) {
                        System.out.println(response);
                        obj = getJsonObjectHttp(response, 0);
                        hateoasApplication.saveInFile(obj, i);
                    } else {
                        URL url = new URL(obj.get("next").toString());
                        HttpGet getRequestNew = new HttpGet(url.toString());
                        getRequestNew.addHeader("accept", "application/json");
                        HttpResponse responseNew = httpClient.execute(getRequestNew);
                        JSONObject objnew = getJsonObjectHttp(responseNew, i);
                        hateoasApplication.saveInFile(objnew, i);
                        obj = objnew;
                    }
                    i++;

                } while (i <= Constants.no_of_pages - 1);
                httpClient.getConnectionManager().shutdown();
            }
        }
        catch(RuntimeException e){
            e.getStackTrace();
        }
    }



    //Method to get a json object from the content of a get call when using httpClient
    public JSONObject getJsonObjectHttp(HttpResponse response, int i) throws IOException, ParseException {
        BufferedReader br = new BufferedReader(new InputStreamReader((response.getEntity().getContent())));
        String output;
        output=br.readLine();
        JSONParser parser = new JSONParser();
        JSONObject obj = (JSONObject) parser.parse(output);
        return obj;
    }


}
