package com.nisum.Clients;

import com.nisum.HateoasApplication;
import com.nisum.constants.Constants;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.web.client.RestTemplate;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;



public class RestTemplateClient {

    @Autowired
    HateoasApplication hateoasApplication;


    @Bean
    public RestTemplate getRestTemplate() {
        return new RestTemplate();
    }

    //using Spring Rest Template(Method 1)
    public void getUsingRestTemplate()  {
        try {
            int i = 0;
            JSONObject obj = null;
            do {
                if (i == 0) {
                    obj = getJSONObject(Constants.URL_EMPLOYEES);
                    hateoasApplication.saveInFile(obj, 0);
                } else {
                    JSONObject objnew = getJSONObject(obj.get("next").toString());
                    hateoasApplication.saveInFile(objnew, i);
                    obj = objnew;
                }
                i++;
            } while (i <= Constants.no_of_pages - 1);
        }
        catch(ParseException e){
            e.getStackTrace();
        }
        catch(IOException ex){
            ex.getStackTrace();
        }
    }

    //Method to get a json object from the content of a get call when using rest template
    public JSONObject getJSONObject(String URL) throws ParseException {
        String result = getRestTemplate().getForObject(URL, String.class);
        JSONParser parser = new JSONParser();
        JSONObject obj = (JSONObject) parser.parse(result);
        return obj;
    }


}
