package com.nisum.controller;


import com.nisum.model.FirstResponse;
import com.nisum.model.User;
import com.nisum.model.Users;
import com.nisum.service.UserServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.apache.tomcat.util.file.ConfigurationSource;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.hateoas.Resource;
import org.springframework.hateoas.mvc.ControllerLinkBuilder;
import org.springframework.util.StreamUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.client.RestTemplate;


import javax.ws.rs.HttpMethod;
import javax.ws.rs.QueryParam;
import java.io.File;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

import static org.springframework.hateoas.mvc.ControllerLinkBuilder.linkTo;

@Slf4j
@RestController
@RequestMapping(value = "/start")
public class UserController {
    public int startOffset=0;

    @Autowired
    UserServiceImpl userServiceImpl;

    @Autowired
    private RestTemplate restTemplate;

    @GetMapping("/users/firstpage")
    public Resource<FirstResponse>  getFirstPage() {
        FirstResponse fr=new FirstResponse();
        log.info("Getting all Users...");
        Resource<FirstResponse> resource=new Resource<>(fr);
        ControllerLinkBuilder linkTo=linkTo(ControllerLinkBuilder.methodOn(this.getClass()).getAllUsers(0));
        resource.add(linkTo.withRel("all_users"));
        return resource;
    }

    @GetMapping("/users/{startOffset}")
    public Users getAllUsers(@PathVariable("startOffset") int startOffset) {
        return userServiceImpl.getAllUsers(startOffset);
    }


}
