package com.nisum.service;

import com.nisum.constants.Constants;

import com.nisum.controller.UserController;
import com.nisum.model.User;


import com.nisum.model.Users;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.hateoas.Resource;
import org.springframework.hateoas.mvc.ControllerLinkBuilder;
import org.springframework.stereotype.Service;

import java.util.ArrayList;

import java.util.List;

import static com.nisum.constants.Constants.page_size;
import static org.springframework.hateoas.mvc.ControllerLinkBuilder.linkTo;

//Server End Code

@Service
public class UserServiceImpl implements UserService {

    @Autowired
    UserController userController;

    private User buildUser(Integer id,  String name, String place){
        User user=new User(id,name,place);
        return user;
    }


    public List<User> getList(){
        List<User> UserList=new ArrayList<>();
        UserList.add(buildUser(1,"Divisha","Udaipur"));
        UserList.add(buildUser(2,"Ashwarya","Hyderabad"));
        UserList.add(buildUser(3,"Vinit","Delhi"));
        UserList.add(buildUser(4,"Deepika","Jaipur"));
        UserList.add(buildUser(5,"Priyanka","Mumbai"));
        UserList.add(buildUser(6,"Rahul","Pune"));
        UserList.add(buildUser(7,"Dev","Bangalore"));
        UserList.add(buildUser(8,"Kapil","Kochi"));
        UserList.add(buildUser(9,"Sachin","Bhopal"));
        UserList.add(buildUser(10,"Yuvraj","Indore"));
        UserList.add(buildUser(11,"Virat","Ahmedabad"));
        UserList.add(buildUser(12,"Rohit","Kozikhode"));
        UserList.add(buildUser(13,"Virendra","Rohtak"));
        UserList.add(buildUser(14,"Mithali","Ranchi"));
        UserList.add(buildUser(15,"Shafali","Nagpur"));
        UserList.add(buildUser(16,"Harmanpreet","Vishakhapatnam"));
        UserList.add(buildUser(17,"Veda","Sambalpur"));
        UserList.add(buildUser(18,"Smriti","Jamshedpur"));
        UserList.add(buildUser(19,"Sania","Goa"));
        UserList.add(buildUser(20,"Usha","Noida"));
        return UserList;

    }


    @Override
    public  Users getAllUsers(int startOffset) {
        int i ;
        for (i = 0; i <= getList().size(); i = i + page_size) {
        List<User> subList = getList().subList(startOffset, startOffset + page_size);
        Users userList = new Users();
        userList.setUsers(subList);
        userList.setPage_no((startOffset/page_size)+1);
        Resource<Users> resource = new Resource<Users>(userList);
        ControllerLinkBuilder next = linkTo(ControllerLinkBuilder.methodOn(UserController.class).getAllUsers(startOffset + page_size));
        ControllerLinkBuilder previous = linkTo(ControllerLinkBuilder.methodOn(UserController.class).getAllUsers(startOffset-page_size ));

        if(startOffset==getList().size()-page_size) {
                userList.setNext(null);
            }
        else {
            userList.setNext(next.toUri());
        }
        if (startOffset == 0){
            userList.setPrevious(null);
        }
        else
        {
            userList.setPrevious(previous.toUri());
        }

        resource.add(next.withRel("all_users"));

        return userList;
        }
        return null;
        }


    }

